/* Time-4-Z Scheduler Front End ver 0.9 */
/* for the Z! text-mode MP3 player by dink, http://dink.org/z/ 
   begun 11-16-06; first recording 11-28-06
   spooling to RAM, much clean up and improvement 04-05-07 */

call rxfuncadd 'SysLoadFuncs','RexxUtil','SysLoadFuncs'
call sysloadfuncs
Call SysCurState 'OFF'
call syscls

/* style point, placing of "=": var= assignment; var = test */

/* ANSI screen color thanks to someone, modified a little */
black= 0; red= 1; green= 2; yellow= 3; blue= 4; magenta= 5; cyan= 6; white= 7;
fgnd= 30         /* add color: 30 + 2= 32 ==> green foreground */
bgnd= 40         /* add color: 40 + 7= 47 ==> white background */
AEsc= '1B'x || '['  /* define ANSI-Escape; + 0 = low, 1 = high int*/
l_wh_bk= AEsc||'0;'||fgnd + white||';'||bgnd + black||'m'
l_bk_wh= AEsc||'0;'||fgnd + black||';'||bgnd + white||'m'
call charout, l_wh_bk /* ensure low white on black esp after testing */

/* these VARs are pretty much CONSTANTS */
sched_name= 'C:\TZ\TZ.SCH'
numday= 'SunMonTueWedThuFriSat'
pipe_to= ' 1>\pipe\zmp3' /* the "1" refers to stdout; here for info because
  highly confusing when REXX changes literal " > \pipe\zmp3" to this anyway */
legend.1= d2c(205)||' MP3s in dir' /* change graphics key chars HERE */
legend.2= d2c(240)||'   & random'
legend.3= d2c(175)||' Stream'
legend.4= d2c(247)||'   & random'
legend.5= d2c(254)||' Record'
secsaday= 86400 /* seconds a day */

/* this section of VARs are semi-constant seldom changed */
save_path= ''
slin.0= 0 /* schedule file, 0 holds # of lines read */
show.0= '' /* "array" for display. Initialized here only for info. */
ref.0= '' /* similar to above, reference to line numbers of tz.sch */
pl.0= 0 /* playlist */

/* following actually change */
curlin= '' /* current line running of tz.sch; when \= the character of
  pseudo-array ref.[hour, minute], then some action is needed */
startday= ''
curact= ''
sleeptime= 1
refc= d2c(255) /* just to ensure \= to curlin */
last_message= '' /* avoids some tangles knowing which stream is playing */
interval= secsaday /* yet another kludge tacked on along with below */ 
split= secsaday /* time in seconds to split recordings */
looptime= 0  /* counts seconds to change random streams or split recordings */
move2= '' /* flag, set to dtfn formed below, without paths */
ready2move= '' /* 2nd flag, preserving if started writing another file */

do forever
  if startday \= date('S') then do /* 1st run or passed midnight */
    startday = date('S')
    call read_file
    call syscls
    call interp_sched
    call show_sched
  end
  key = ''
  if chars()>0 then do
    key= sysgetkey('noecho')
    key= translate(key)
    if key = '`' then do  /* Refresh attempt for stream errors... */
      curlin= '0' /* triggers "new action" below; stops writing, quits z */
      if curact = 'REC' then split= secsaday
    end
    else if key = '~' then do /* "Rem out" the current action to STOP it */
      curlin= '0' /* triggers "new action" below; stops writing, quits z */
      refc= c2d(value('refc')) /* un-de-code the line # */
      slin.refc= '~'||slin.refc /* add tilde; remove to restore line... */
      call interp_sched /* and start over with that line being skipped */
    end
    else select /* available commands vary with current action (keyword) */
      when curact = 'RST' then do
        /* Move (to picked directory in TZ) */
        select
          when key = 'N' then do /* New, tho simple random may pick same... */ 
            call z_quit
            call syssleep 1
            call random_stream
            end
          when key = 'S' then interval= secsaday /* Stay on station */
          otherwise nop
        end /* RST key select */
        looptime= 0 /* for now, any key resets timer */
      end
      otherwise nop
    end /* outer select */
  end
  else call syssleep sleeptime
  if key = 'X' then leave
  parse value time('N') with ch ':' cm ':' cs /* this mess flashes char */
  if pos('0', ch) = 1 then ch= delstr(ch, 1, 1)
  if pos('0', cm) = 1 then cm= delstr(cm, 1, 1)
  if pos(substr(cs, 2, 1), '02468') > 0 then call charout, l_bk_wh
  call syscurpos ch, cm + 19 /* offset on screen */
  showc= substr(show.ch, cm + 4, 1)
  call charout, showc
  call charout, l_wh_bk
  if pos(':00:00', now) = 3 then call show_sched /* hourly full refresh */
  now= time('N')
  call syscurpos 23, 1
  call charout, now
  refc= substr(ref.ch, cm + 1, 1)
  looptime= looptime + 1
  /* CHECK IF NEW ACTION REQUIRED - (starts schedule even from middle) */
  if (curlin \= refc) | (looptime > interval) | (looptime > split) then DO
    interval= secsaday /* reset to max every pass through here */
    if curlin \= '' then do /* presumably every time except very first */
      if writing = 1 then do
        call z_writetodisk '' 
        call message 'STOP writing...'
        writing= 0
        if move2 \= '' then do
          call message 'Setting MOVE flag...'
          ready2move= move2
        end
        else ready2move= ''
      /* problem of missing a recorded segment seems to occur right here */
      /* possibly because the drive has been spun down, so */
        call syssleep 10  /* give system PLENTY of time to react... */
      end /* writing */
      if split = secsaday then do /* don't quit Z if splitting */
        call z_quit /* QUIT */
        call message 'Telling Z to quit...'
        call syssleep 3
      end
      move2= '' /* always set flag off */
    end /* curlin \= '' */

    /* REXX is just REPLETE with contortions; better explain this one to _me_*/
    refc= c2d(value('refc')) /* refc is char = line #; convert it to _#_ */
    curlin= slin.refc /* to refer to slin.# - curlin only a handy var here */
    /* n.b. curlin= value('slin.'refc) looks more elegant, but doesn't work */
    /* and tried other variations without success; the above works FINE */

    /* 2nd command because seems to not reliably QUIT after a stop writing */
    if refc = 0 then do
      call z_quit
      call message 'No event scheduled; again sending QUIT to Z...'
      call syssleep 3
    end
    kw= translate(left(curlin, 3)) /* vars duplicated from interp */
    /* days= word(curlin, 2) UNNECESSARY here: process only in interp */
    parse value word(curlin.ndx, 3) with sth ':' stm
    dur= word(curlin, 4)
    /* MAY BE OTHER PARAMETERS HERE, processed by each type */
    remdr= right(curlin, length(curlin) - lastpos(':\', curlin) + 2)
    /* the above depends on each key type specifying drive:\dir last */
    select   /* start Z EVERY time; avoids problem when changing from */
      /* stream to local; Z EXITS then anyway - see z_stream proc below, */
      /* seems streams can't use pipe, REQUIRE COMMAND LINE PARMS?! */
      when kw= 'DIR' then do
        call z_start
        if lastpos('\', remdr) <> length(remdr) then remdr= remdr||'\'
        rc= sysfiletree(remdr||'*.MP3', "list.", "FSO")
        do n= 1 to list.0
        list.n= '"'||list.n||'"'
          if pos('.MP3', list.n) > 0 | pos('.mp3', list.n) > 0 then
            call z_play list.n
          call syssleep 3 /* hmm; is this enough time? */
        end
      end
      when kw= 'RAN' then do
        call z_start
        /* er... somewhat hazy after that */
      end
      when kw= 'STR' then do
        call message d2c(22)||' Streaming: 'remdr
        call z_stream remdr
        call syssleep 3
      end
      when kw= 'RST' then do
        interval= word(curlin, 5)
        if datatype(interval) <> 'NUM' then interval= dur
        interval= interval * 60 /* convert to seconds */
        call get_playlists remdr
        call random_stream
      end
      when kw= 'REC' then do
        if pos('PATH', curlin) > 0 then do
          i= pos('"', curlin) + 1
          spool_path= substr(curlin, i, lastpos('"', curlin) - 1 - i)
        end
        else spool_path= save_path
        if lastpos('\', spool_path) \= length(spool_path) then
          spool_path= spool_path||'\'
        if split = secsaday then do /* start only if 1st pass */
          call z_stream remdr
          call message 'Z should be buffering stream: 'remdr
          call syssleep 3
        end
        if wordpos('SPLIT', curlin) > 0 then do
          split= word(curlin, wordpos('SPLIT', curlin) + 1)
          split= split * 60 /* seconds */
        end
        else split = secsaday 
        dtfn= substr(date('S'), 3, 6)||'_'||substr(time('N'), 1, 5)
        dtfn= delstr(dtfn, 10, 1) /* keep name separate for easy MOVE */
        if pos('MOVE', curlin) > 0 then move2= dtfn /* ^also a flag */
        dtfn= spool_path||dtfn
        call z_writetodisk dtfn
        call message 'Z should start writing file 'dtfn
        call syssleep 3
        call message d2c(22)||' Recording: 'remdr
        writing= 1
      end
    otherwise nop
    end /* select RUN */
    if ready2move \= '' then do /* FILE WAITING TO BE MOVED */
    /* could get rid of "1 file(s) copied" clutter with ">nul" */
      call syscls 
      say ' Moving recorded file and cleaning up...'
      say
      'copy 'spool_path||ready2move||'.MP3 '||save_path
      call syssleep 3
      'del 'spool_path||ready2move||'.MP3'
      'del 'spool_path||ready2move||'.MP3.TXT'
      call syssleep 1
      ready2move= ''
    end
    if kw <> 'REC' then split= secsaday
    curlin= substr(ref.ch, cm + 1, 1) /* now current line # for outer loop */
    curact= kw
    call syscls
    call show_sched
    call syscurpos 19, 1
    call charout, 'Running # '||c2d(curlin)
    looptime= 0
  end /* curlin \= refc */
end /* main loop */
exit

message:
  parse arg m
  m= left(m, 78) /* n.b. left() PADS with spaces, handy here */
  call syscurpos 24, 1
  call charout, m
  last_message= m /* kludge for persistent messages, such as stream name */
return

get_playlists: /* for random stream */
  parse arg pld
  if lastpos('\', pld) \= length(pld) then pld= pld||'\'
  pld= pld||'*'
  drop pl. /* clear any existing playlist */
  rc= SysFileTree(pld, "pl.", "FO")
  i= 1
  do while i <= pl.0 /* get rid of any non-playlist */
    fext= translate( right(pl.i, (length(pl.i) - lastpos(".", pl.i) + 1 )))
    if fext <> '.M3U' & fext <> '.PLS' then do
      do j= i to pl.0
        k= j + 1 /* hmm; how does one handle math on stem. #s? */
        pl.j= pl.k 
      end
      drop pl.j
      pl.0= pl.0 - 1
    end
    i= i + 1
  end /* while */
return

random_stream:
  r= random(1, pl.0)
  call message d2c(22)||' Random Stream: 'pl.r /* persistent message */
  call z_stream pl.r
return
 
read_file:
if stream(sched_name, 'c', 'query exists') <> '' then do
  say 'Reading schedule...'  /* KEEP ALL lines for easy reference in .sch */
  ndx= 1
  do until lines(sched_name) = 0 /* make some minor modifications to text */
    tline= strip(linein(sched_name), 'B', ' ') /* filename case preserved */
    p= pos(':', tline) /* remove leading zeros now for later ease */
    if p > 0 then if substr(tline, p - 2, 1) = '0' then
      tline= delstr(tline, p - 2, 1)
    p= pos(':', tline) /* remove leading zeros now for later ease */
    if p > 0 then if substr(tline, p + 1, 1) = '0' then
      tline= delstr(tline, p + 1, 1)
    slin.ndx= tline
    ndx= ndx + 1
  end
  ok= stream(sched_name, 'c', 'close')
  slin.0= ndx - 1
end /* file exists */
else do 
  say 'Cannot find schedule file...'
  exit
end
return

init_scheds:  /* ref.23 used temporary for convenience */
ref.23= '|'||copies('', 4)||d2c(179)||copies('', 4)||d2c(179)||copies('', 4)
do l=0 to 23
  show.l= l||' '||copies(ref.23, 4) /* copy 4 of quarter hour marks */
  if (l<10) then show.l='0'||show.l
  ref.l= copies(d2c(0), 60)
end
return

/* not yet implemented check for min free space and erase older files...
  freespace = word(SysDriveInfo(word(dm, n)), 2)
  if freespace < free_size then do
  end
*/

interp_sched:
day= substr(date('W'), 1, 3)
nd= (pos(day, numday) - 1) / 3 + 1 /* find a # 1-7 representing day */
call init_scheds
do ndx= 1 to slin.0
  if pos('SAVEPATH', slin.ndx) = 1 then do
    save_path= right(slin.ndx, length(slin.ndx) - wordindex(slin.ndx, 2) + 1)
    curdir= directory() /* must save start point */
    rc= directory(save_path) /* changes TO if exists! */
    call directory(curdir) /* change back on logged drive */
    if rc= '' then do /* null means does not exist */
      rc= sysmkdir(save_path)
      if rc <> 0 then do
        say 'Problem creating directory 'save_path
        exit
      end
    end
  end
  kw= translate(left(slin.ndx, 3))
  select /* set graphics char (from legend.) for pseudo-array show. */
    when kw= 'DIR' then oc= substr(legend.1, 1, 1)
    when kw= 'RAN' then oc= substr(legend.2, 1, 1)
    when kw= 'STR' then oc= substr(legend.3, 1, 1)
    when kw= 'RST' then oc= substr(legend.4, 1, 1)
    when kw= 'REC' then oc= substr(legend.5, 1, 1)
  otherwise oc= '?'
  end /* select */
  if oc \= '?' then do  /* to skip if no keyword found */
    days= word(slin.ndx, 2)
    if substr(days, nd, 1) = substr(day, 1, 1) then do
      parse value word(slin.ndx, 3) with sth ':' stm
      dur= word(slin.ndx, 4)
      remdr= right(slin.ndx, length(slin.ndx) - lastpos('\', slin.ndx))
      remdr= oc||remdr
      if kw= 'RST' then remdr= remdr||' '||word(slin.ndx, 5)
      if wordpos('SPLIT', slin.ndx) > 0 then do
        p= word(slin.ndx, wordpos('SPLIT', slin.ndx) + 1)
        remdr= remdr||' '||p
      end
      if length(remdr) + 5 > dur then remdr = left(remdr, dur - 5)
      cl= sth
      n= 1
      m= stm
      do while n <= dur
        select
        when n = 1 then tc= ''
        when n = 2 then tc= d2c(16)
        when n > 2 & n < length(remdr) + 3 then tc = substr(remdr, n - 2, 1)
        when n = dur - 1 then tc= d2c(17)
        when n = dur then tc= ''
        otherwise tc= oc /* if possible fill out with code char */
        end
        show.cl= overlay(tc, show.cl, m + 4) /* offset in show. for hour digits */
        ref.cl= overlay(d2c(ndx), ref.cl, m + 1)
        n= n + 1
        m= m + 1
        if m > 59 then do
          cl= cl + 1
          if cl > 23 then cl= 0 /* primitive protection; just wraps around */
          m= 0
        end
      end /* while n <= dur */
    end /* passed check, runs today */
  end /* oc \= '?' */
end /* do */
return /* interpret */

show_sched:
do l= 0 to 23
  call syscurpos l, 1
  select /* for displaying various info */
    when (l > 0) & (l < 6) then call charout, legend.l
    when l = 21 then call charout, date('N')
    when l = 22 then call charout, date('W')
    otherwise nop
  end
  call syscurpos l, 16
  call charout, show.l
  if substr(last_message, 1, 1) = d2c(22) then do
    call syscurpos 24, 1
    call charout, last_message
  end
end
return

exit /* catch all slips through... */


/* Z pipe control -------------------------------------------------------- */

/* START procedured because of need to repeat calls: exits when streaming */
z_start:
'@start "Z for named pipe" /N /B /PGM "C:\Z28\Z.EXE"'
call syssleep 3 /* give system some time... */
return

/* pause            - pause playback */
z_pause:
'@echo *pause' pipe_to
return

/* mute             - mute playback */
z_mute:
'@echo *mute' pipe_to
return

/* next             - jumps to the next track */
z_next:
'@echo *next' pipe_to
return

/* previous         - jumps to the previous track */
z_previous:
'@echo *previous' pipe_to
return

/* stop             - stops playback and returns to the file-selector */
z_stop:
'@echo *stop' pipe_to
return

/* seek [x]         - seek to position in track (in seconds, -# to seek back */
z_seek:
'@echo *seek' pipe_to
return

/* vol+             - raises the volume a bit */
z_volraise:
'@echo *vol+' pipe_to
return

/* vol-             - lowers the volume a bit */
z_vollower:
return
'@echo *vol-' pipe_to

/* quit             - quits z! */
z_quit:
'@echo *quit' pipe_to
return

/* play [x]         - plays file [x] if not already playing something, */
/*                    otherwise it just adds to the playlist */
z_play:
parse arg fs
'@echo *play 'fs pipe_to
return

/* STREAMING would use z_play IF it worked as expected, but doesn't seem */
/* to accept .pls from named pipe, so calling Z directly... */
z_stream:
parse arg fs
'@start "Z for named pipe" /N /B /PGM "C:\Z28\Z.EXE"' fs
call syssleep 3 /* hope enough time to establish stream... */
return

/* add [x]          - adds file [x] to the playlist */
z_add:
parse arg fs
'@echo *add' pipe_to
return

/* addlist [x]      - adds all the files in the playlist file [x] */
z_addlist:
parse arg pls
'@echo *addlist' pls pipe_to
return

/* addnext [x]      - adds file [x] after the current playing file */
z_addnext:
'@echo *addnext' pipe_to
return

/* shout [x]        - immediately plays file [x] then continues w/playlist */
z_shout:
'@echo *shout' pipe_to
return

/* clearlist        - clears the playlist */
z_clearlist:
'@echo *clearlist 'fs pipe_to
return

/* writetodisk [fn] - save http stream to [fn] (no [fn] = stop writing) */
z_writetodisk:
parse arg fs
'@echo *writetodisk 'fs pipe_to
return
